
# Signal Handling in LRS

CURRENTLY UNSTRUCTURED NOTES, DO NOT READ!

## Distributed Execution TST Tree

We have a distributed TST tree that conceptually can be seen as a
global tree which are synchronized between agents.

## External Signal Server

This server seems to solve the issue with situations when we have a
trigger event for example "low battery" but we do not know in advance
who should be signaled about this event.

Have the following services:

- register_node_to_signal : A node can here be either a TST node or a ROS node
- activate_signal

Subscribe on:

- /signal_server_command (is distributed)

Publishes:

- tst_signal_executor (is NOT distributed): Alls signals sent on this topic when 

Service RegisterNodeToSignal:

```bash
string uuid                 # uuid for reciever of signal, can be a TST node or a ROS node.
string signal               # Signal to send
string type                 # If a TST node this is the type (needed for access), if external set to "".
float64 duration            # If oneshot false, send signal regularly with period duration (given in seconds).
bool   oneshot              # if true send signal only once
bool remove                 # If true remove the registration with uuid
---
bool success             # The call was OK
int32 error
string reason
```

Service ActivateSignal:

Triggers sending of signal either oneshot or repeat.

```bash
#
# call to signal server to activate or deactivae
# a named signal. Can be used by an external detector or a TST node detector.
#

string signal               # Signal to activate
bool activate               # if true activate, if false deactivate
---
bool success             # The call was OK
int32 error
string reason
```

The signal server commands are:

- ACTIVATE
- DEACTIVATE
- RESET
- RESET_ACTIVE
- RESET_SIGNALS

## SignalTree: Abort

   - For all terminals tha have not executed set "abort_when_starting" flag.
   - Distribute this change to all other instances of the TST tree on other robots
   - For all abortable nodes that are axecuting: send $abort signal to the node (signal distributed to all robots)
   - QUERY: Is external server used here???

## SignalTree: Enough

   - For all enoughable nodes that are executing: send $enough signal to the node (signal distributed to all robots)
   - QUERY: Is external server used here???

## SignalTree: Pause

   - For all pauseable nodes that are executing: send $pause signal to the node (signal distributed to all robots)
   - QUERY: Is external server used here???

## SignalTree: Continue

   - For all pauseable nodes that are executing: send $continue signal to the node (signal distributed to all robots)
   - QUERY: Is external server used here???


## Send Signal from a Node

## Send Signal from Ordinary Program

## Who can receive Signals?